Index: src/sas/sasgui/perspectives/fitting/fitting.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitting.py	(revision a5cffe570a689752aa7b74ce8a71d2b1704e624f)
+++ src/sas/sasgui/perspectives/fitting/fitting.py	(revision a5cffe570a689752aa7b74ce8a71d2b1704e624f)
@@ -147,5 +147,5 @@
         Given an ID create a fitproblem container
         """
-        if page_id in self.page_finder.iterkeys():
+        if page_id in self.page_finder:
             del self.page_finder[page_id]
 
@@ -356,5 +356,5 @@
             # categories, the updated plugin may be in either the form factor
             # or the structure factor combo boxes
-            for uid, page in self.fit_panel.opened_pages.iteritems():
+            for uid, page in self.fit_panel.opened_pages.items():
                 pbox = getattr(page, "formfactorbox", None)
                 sbox = getattr(page, "structurebox", None)
@@ -417,6 +417,6 @@
                 self.fit_panel.SetSelection(current_page_index)
 
-        except Exception:
-            logger.error("update_custom_combo: %s", sys.exc_value)
+        except Exception as exc:
+            logger.error("update_custom_combo: %s", exc)
 
     def set_edit_menu(self, owner):
@@ -642,6 +642,6 @@
                             data.list_group_id.append(group_id)
                         self.add_fit_page(data=[data])
-            except:
-                msg = "Fitting set_data: " + str(sys.exc_value)
+            except Exception as exc:
+                msg = "Fitting set_data: " + str(exc)
                 wx.PostEvent(self.parent, StatusEvent(status=msg, info="error"))
 
@@ -654,8 +654,8 @@
                 _, theory_state = item
                 self.fit_panel.set_model_state(theory_state)
-            except Exception:
+            except Exception as exc:
                 msg = "Fitting: cannot deal with the theory received"
                 evt = StatusEvent(status=msg, info="error")
-                logger.error("set_theory " + msg + "\n" + str(sys.exc_value))
+                logger.error("set_theory " + msg + "\n" + str(exc))
                 wx.PostEvent(self.parent, evt)
 
@@ -778,5 +778,5 @@
         # Note: this is used to set the data weights for the fit based on
         # the weight selection in the GUI.
-        if uid in self.page_finder.keys():
+        if uid in self.page_finder:
             self.page_finder[uid].set_weight(flag=flag, is2d=is2d)
 
@@ -791,5 +791,5 @@
         :param qmax: maximum  value of the fit range
         """
-        if uid in self.page_finder.keys():
+        if uid in self.page_finder:
             self.page_finder[uid].set_range(qmin=qmin, qmax=qmax, fid=fid)
 
@@ -802,5 +802,5 @@
         :param uid: the id related to a page containing fitting information
         """
-        if uid in self.page_finder.keys():
+        if uid in self.page_finder:
             self.page_finder[uid].schedule_tofit(value)
 
@@ -821,5 +821,5 @@
         """
         sim_page_id = self.sim_page.uid
-        for uid, value in self.page_finder.iteritems():
+        for uid, value in self.page_finder.items():
             if uid != sim_page_id and uid != self.batch_page.uid:
                 model_list = value.get_model()
@@ -886,5 +886,5 @@
         Stop the fit
         """
-        if uid in self.fit_thread_list.keys():
+        if uid in self.fit_thread_list:
             calc_fit = self.fit_thread_list[uid]
             if calc_fit is not  None and calc_fit.isrunning():
@@ -898,7 +898,7 @@
         batch_flag = self.batch_page is not None and uid == self.batch_page.uid
         if sim_flag or batch_flag:
-            for uid, value in self.page_finder.iteritems():
+            for uid, value in self.page_finder.items():
                 if value.get_scheduled() == 1:
-                    if uid in self.fit_panel.opened_pages.keys():
+                    if uid in self.fit_panel.opened_pages:
                         panel = self.fit_panel.opened_pages[uid]
                         panel._on_fit_complete()
@@ -917,5 +917,5 @@
         :param draw: Determine if the theory needs to be plot
         """
-        if uid not in self.page_finder.keys():
+        if uid not in self.page_finder:
             return
         self.page_finder[uid].enable_smearing(flag=enable_smearer)
@@ -928,5 +928,5 @@
                 msg += "Got data = %s .\n" % str(data)
                 return
-                #raise ValueError, msg
+                #raise ValueError(msg)
             model = self.page_finder[uid].get_model(fid=fid)
             if model is None:
@@ -1030,5 +1030,5 @@
         list_page_id = []
         fit_id = 0
-        for page_id, page_info in self.page_finder.iteritems():
+        for page_id, page_info in self.page_finder.items():
             # For simulfit (uid give with None), do for-loop
             # if uid is specified (singlefit), do it only on the page.
@@ -1057,6 +1057,5 @@
 
                     pars = [str(element[1]) for element in page.param_toFit]
-                    fitproblem_list = page_info.values()
-                    for fitproblem in  fitproblem_list:
+                    for fitproblem in page_info.values():
                         if sim_fitter is None:
                             fitter = Fit()
@@ -1077,7 +1076,7 @@
                 wx.PostEvent(self.parent, evt)
                 return True
-            except:
+            except Exception as exc:
                 raise
-                msg = "Fitting error: %s" % str(sys.exc_value)
+                msg = "Fitting error: %s" % exc
                 evt = StatusEvent(status=msg, info="error", type="stop")
                 wx.PostEvent(self.parent, evt)
@@ -1136,5 +1135,5 @@
         :param fid: the id of the fitproblem(data, model, range,etc)
         """
-        if uid not in self.page_finder.keys():
+        if uid not in self.page_finder:
             return
         fitproblemList = self.page_finder[uid].get_fit_problem(fid)
@@ -1181,6 +1180,6 @@
                 evt = StatusEvent(status=msg, info="warning")
                 wx.PostEvent(self.parent, evt)
-        except Exception:
-            msg = "Creating Fit page: %s" % sys.exc_value
+        except Exception as exc:
+            msg = "Creating Fit page: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg, info="error"))
 
@@ -1262,9 +1261,9 @@
         # case that uid is not specified
         if uid is None:
-            for page_id in self.page_finder.keys():
+            for page_id in self.page_finder:
                 self.page_finder[page_id].schedule_tofit(value)
         # when uid is given
         else:
-            if uid in self.page_finder.keys():
+            if uid in self.page_finder:
                 self.page_finder[uid].schedule_tofit(value)
 
@@ -1300,5 +1299,5 @@
         panel = self.plot_panel
         if panel is None:
-            raise ValueError, "Fitting:_onSelect: NonType panel"
+            raise ValueError("Fitting:_onSelect: NonType panel")
         Plugin.on_perspective(self, event=event)
         self.select_data(panel)
@@ -1333,5 +1332,5 @@
         """
         uid = page_id[0]
-        if uid in self.fit_thread_list.keys():
+        if uid in self.fit_thread_list:
             del self.fit_thread_list[uid]
 
@@ -1359,16 +1358,16 @@
                 #get all fittable parameters of the current model
                 for param in  model.getParamList():
-                    if param  not in batch_outputs.keys():
+                    if param  not in batch_outputs:
                         batch_outputs[param] = []
                 for param in model.getDispParamList():
                     if not model.is_fittable(param) and \
-                        param in batch_outputs.keys():
+                        param in batch_outputs:
                         del batch_outputs[param]
                 # Add fitted parameters and their error
                 for param in res.param_list:
-                    if param not in batch_outputs.keys():
+                    if param not in batch_outputs:
                         batch_outputs[param] = []
                     err_param = "error on %s" % str(param)
-                    if err_param not in batch_inputs.keys():
+                    if err_param not in batch_inputs:
                         batch_inputs[err_param] = []
         msg = ""
@@ -1524,5 +1523,5 @@
         model = fitproblem.get_model()
         #fill batch result information
-        if "Data" not in batch_outputs.keys():
+        if "Data" not in batch_outputs:
             batch_outputs["Data"] = []
         cell = BatchCell()
@@ -1553,6 +1552,6 @@
         cell.object = [data, theory_data]
         batch_outputs["Data"].append(cell)
-        for key, value in data.meta_data.iteritems():
-            if key not in batch_inputs.keys():
+        for key, value in data.meta_data.items():
+            if key not in batch_inputs:
                 batch_inputs[key] = []
             #if key.lower().strip() != "loader":
@@ -1560,5 +1559,5 @@
         param = "temperature"
         if hasattr(data.sample, param):
-            if param not in  batch_inputs.keys():
+            if param not in  batch_inputs:
                 batch_inputs[param] = []
             batch_inputs[param].append(data.sample.temperature)
@@ -1631,7 +1630,6 @@
                     wx.PostEvent(self.parent, evt)
 
-        except Exception:
-            msg = ("Fit completed but the following error occurred: %s"
-                   % sys.exc_value)
+        except Exception as exc:
+            msg = "Fit completed but the following error occurred: %s" % exc
             #msg = "\n".join((traceback.format_exc(), msg))
             evt = StatusEvent(status=msg, info="warning", type="stop")
@@ -1721,5 +1719,5 @@
         if model is None:
             return
-        if uid not in self.page_finder.keys():
+        if uid not in self.page_finder:
             return
         # save the name containing the data name with the appropriate model
@@ -2078,7 +2076,7 @@
                                   source=source)
             self.calc_1D.queue()
-        except:
+        except Exception as exc:
             msg = " Error occurred when drawing %s Model 1D: " % model.name
-            msg += " %s" % sys.exc_value
+            msg += " %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg))
 
Index: src/sas/sasgui/perspectives/fitting/model_thread.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/model_thread.py	(revision 0f9ea1cee80a92f71e4bec65998ca56a3de65fd6)
+++ src/sas/sasgui/perspectives/fitting/model_thread.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -65,5 +65,5 @@
         if self.data is None:
             msg = "Compute Calc2D receive data = %s.\n" % str(self.data)
-            raise ValueError, msg
+            raise ValueError(msg)
 
         # Define matrix where data will be plotted
Index: src/sas/sasgui/perspectives/fitting/resultpanel.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/resultpanel.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/fitting/resultpanel.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -59,5 +59,5 @@
     def on_plot_results(self, event):
         self.frame.Show(True)
-        result = event.result[0][0]
+        result = list(event.result[0])[0]
         filename = result.data.sas_data.filename
         current_time = datetime.datetime.now().strftime("%I:%M%p, %B %d, %Y")
Index: src/sas/sasgui/perspectives/fitting/simfitpage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/simfitpage.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
+++ src/sas/sasgui/perspectives/fitting/simfitpage.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -168,5 +168,5 @@
         i = 0
         for model in self.model_list:
-            model_id = self._format_id(model[1].keys()[0])
+            model_id = self._format_id(list(model[1].keys())[0])
             for saved_model in sim_state.model_list:
                 save_id = saved_model.pop('name')
@@ -328,5 +328,5 @@
         sizer.Add(tab_used, (iy, ix), (1, 1),
                   wx.EXPAND | wx.ADJUST_MINSIZE, 0)
-        for id, value in self.page_finder.iteritems():
+        for id, value in self.page_finder.items():
             if id not in self.parent.opened_pages:
                 continue
@@ -757,10 +757,10 @@
         self.set_button.Disable()
 
-        for id, model in self.constraint_dict.iteritems():
+        for id, model in self.constraint_dict.items():
             # check if all parameters have been selected for constraint
             # then do not allow add constraint on parameters
             self.model_cbox_left.Append(str(model.name), model)
         self.model_cbox_left.Select(0)
-        for id, model in self.constraint_dict.iteritems():
+        for id, model in self.constraint_dict.items():
             # check if all parameters have been selected for constraint
             # then do not allow add constraint on parameters
@@ -814,5 +814,5 @@
         model_right = self.model_cbox_right.GetValue()
         model_b = self.model_cbox_right.GetClientData(selection_b)
-        for id, dic_model in self.constraint_dict.iteritems():
+        for id, dic_model in self.constraint_dict.items():
             if model == dic_model:
                 param_list = self.page_finder[id].get_param2fit()
@@ -857,5 +857,5 @@
         if len(self.constraints_list) != 0:
             nb_fit_param = 0
-            for id, model in self.constraint_dict.iteritems():
+            for id, model in self.constraint_dict.items():
                 nb_fit_param += len(self.page_finder[id].get_param2fit())
             # Don't add anymore
@@ -879,5 +879,5 @@
         model_cbox = wx.ComboBox(self, wx.ID_ANY, style=wx.CB_READONLY)
         model_cbox.Clear()
-        for id, model in self.constraint_dict.iteritems():
+        for id, model in self.constraint_dict.items():
             # check if all parameters have been selected for constraint
             # then do not allow add constraint on parameters
@@ -931,5 +931,5 @@
         hide buttons related constraint
         """
-        for id in self.page_finder.iterkeys():
+        for id in self.page_finder.keys():
             self.page_finder[id].clear_model_param()
 
@@ -969,5 +969,5 @@
         model = model_cbox.GetClientData(n)
         param_list = []
-        for id, dic_model in self.constraint_dict.iteritems():
+        for id, dic_model in self.constraint_dict.items():
             if model == dic_model:
                 param_list = self.page_finder[id].get_param2fit()
@@ -1056,5 +1056,5 @@
                 msg += " in combobox to set constraint! "
                 wx.PostEvent(self.parent.parent, StatusEvent(status=msg))
-            for id, value in self.constraint_dict.iteritems():
+            for id, value in self.constraint_dict.items():
                 if model == value:
                     if constraint == "":
@@ -1080,5 +1080,5 @@
                         return False
 
-                    for fid in self.page_finder[id].iterkeys():
+                    for fid in self.page_finder[id].keys():
                         # wrap in param/constraint in str() to remove unicode
                         self.page_finder[id].set_model_param(str(param),
Index: src/sas/sasgui/perspectives/invariant/__init__.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/__init__.py	(revision 5a405bda2da663894b6b32ab94768a91d60525a4)
+++ src/sas/sasgui/perspectives/invariant/__init__.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -3,5 +3,5 @@
 
 from distutils.filelist import findall
-from invariant import *
+from .invariant import *
 
 def get_data_path(media):
Index: src/sas/sasgui/perspectives/invariant/invariant.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ src/sas/sasgui/perspectives/invariant/invariant.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -133,5 +133,5 @@
             name = data.__class__.__name__
             msg = "Invariant use only Data1D got: [%s] " % str(name)
-            raise ValueError, msg
+            raise ValueError(msg)
         self.compute_helper(data=data)
 
@@ -144,4 +144,6 @@
         if data_list is None:
             data_list = []
+        else:
+            data_list = list(data_list)  # force iterator to list
         if len(data_list) >= 1:
             if len(data_list) == 1:
@@ -190,6 +192,6 @@
                 try:
                     self.compute_helper(data)
-                except:
-                    msg = "Invariant Set_data: " + str(sys.exc_value)
+                except Exception as exc:
+                    msg = "Invariant Set_data: " + str(exc)
                     wx.PostEvent(self.parent, StatusEvent(status=msg, info="error"))
         else:
@@ -240,5 +242,5 @@
             msg = "invariant.save_file: the data being saved is"
             msg += " not a sas.sascalc.dataloader.data_info.Data1D object"
-            raise RuntimeError, msg
+            raise RuntimeError(msg)
 
     def set_state(self, state=None, datainfo=None):
@@ -258,5 +260,5 @@
                 msg = "invariant.set_state: datainfo parameter cannot"
                 msg += " be None in standalone mode"
-                raise RuntimeError, msg
+                raise RuntimeError(msg)
             # Make sure the user sees the invariant panel after loading
             # self.parent.set_perspective(self.perspective)
@@ -281,6 +283,6 @@
             self.on_set_state_helper(None)
 
-        except:
-            logger.error("invariant.set_state: %s" % sys.exc_value)
+        except Exception as exc:
+            logger.error("invariant.set_state: %s" % exc)
 
     def on_set_state_helper(self, event=None):
@@ -320,5 +322,5 @@
         else:
             msg = "Scale can not be zero."
-            raise ValueError, msg
+            raise ValueError(msg)
         if len(new_plot.x) == 0:
             return
Index: src/sas/sasgui/perspectives/invariant/invariant_details.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_details.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
+++ src/sas/sasgui/perspectives/invariant/invariant_details.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -2,9 +2,11 @@
     Invariant panel
 """
+import sys
+
 import wx
-import sys
 
 from sas.sasgui.guiframe.utils import format_number
-from invariant_widgets import OutputTextCtrl
+from .invariant_widgets import OutputTextCtrl
+
 # Dimensions related to chart
 RECTANGLE_WIDTH = 400.0
@@ -33,5 +35,5 @@
 
 
-class InvariantContainer(wx.Object):
+class InvariantContainer:
     """
     This class stores some values resulting resulting from invariant
Index: src/sas/sasgui/perspectives/invariant/invariant_panel.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision 44e8f48e6ada97db8eb483009edc07705c6329a2)
+++ src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -319,10 +319,10 @@
         background = self.background_tcl.GetValue().lstrip().rstrip()
         if background == "":
-            raise ValueError, "Need a background"
+            raise ValueError("Need a background")
         if check_float(self.background_tcl):
             return float(background)
         else:
             msg = "Receive invalid value for background : %s" % (background)
-            raise ValueError, msg
+            raise ValueError(msg)
 
     def get_scale(self):
@@ -332,5 +332,5 @@
         scale = self.scale_tcl.GetValue().lstrip().rstrip()
         if scale == "":
-            raise ValueError, "Need a background"
+            raise ValueError("Need a background")
         if check_float(self.scale_tcl):
             if float(scale) <= 0.0:
@@ -338,8 +338,8 @@
                 self.scale_tcl.Refresh()
                 msg = "Receive invalid value for scale: %s" % (scale)
-                raise ValueError, msg
+                raise ValueError(msg)
             return float(scale)
         else:
-            raise ValueError, "Receive invalid value for scale : %s" % (scale)
+            raise ValueError("Receive invalid value for scale : %s" % (scale))
 
     def get_contrast(self):
@@ -386,9 +386,9 @@
                 self.volume_tcl.SetValue(format_number(v))
                 self.volume_err_tcl.SetValue(format_number(dv))
-            except:
+            except Exception as exc:
                 self.volume_tcl.SetValue(format_number(None))
                 self.volume_err_tcl.SetValue(format_number(None))
                 msg = "Error occurred computing volume "
-                msg += " fraction: %s" % sys.exc_value
+                msg += " fraction: %s" % exc
                 wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                       info="error",
@@ -406,9 +406,9 @@
                 self.surface_tcl.SetValue(format_number(s))
                 self.surface_err_tcl.SetValue(format_number(ds))
-            except:
+            except Exception as exc:
                 self.surface_tcl.SetValue(format_number(None))
                 self.surface_err_tcl.SetValue(format_number(None))
                 msg = "Error occurred computing "
-                msg += "specific surface: %s" % sys.exc_value
+                msg += "specific surface: %s" % exc
                 wx.PostEvent(self.parent, StatusEvent(status=msg, info="error",
                                                       type="stop"))
@@ -426,5 +426,5 @@
             self.inv_container.qstar_total = qstar_total
             self.inv_container.qstar_total_err = qstar_total_err
-        except:
+        except Exception as exc:
             self.inv_container.qstar_total = "Error"
             self.inv_container.qstar_total_err = "Error"
@@ -432,5 +432,5 @@
             self.invariant_total_err_tcl.SetValue(format_number(None))
             msg = "Error occurred computing invariant using"
-            msg += " extrapolation: %s" % sys.exc_value
+            msg += " extrapolation: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg, type="stop"))
 
@@ -450,10 +450,10 @@
                 self._manager.plot_theory(data=extrapolated_data,
                                           name="Low-Q extrapolation")
-            except:
+            except Exception as exc:
                 self.inv_container.qstar_low = "ERROR"
                 self.inv_container.qstar_low_err = "ERROR"
                 self._manager.plot_theory(name="Low-Q extrapolation")
                 msg = "Error occurred computing low-Q "
-                msg += "invariant: %s" % sys.exc_value
+                msg += "invariant: %s" % exc
                 wx.PostEvent(self.parent,
                              StatusEvent(status=msg, type="stop"))
@@ -462,6 +462,6 @@
             try:
                 self._manager.plot_theory(name="Low-Q extrapolation")
-            except:
-                logger.error(sys.exc_value)
+            except Exception as exc:
+                logger.error(exc)
 
     def get_high_qstar(self, inv, high_q=False):
@@ -483,5 +483,5 @@
                 self._manager.plot_theory(data=high_out_data,
                                           name="High-Q extrapolation")
-            except:
+            except Exception as exc:
                 #raise
                 self.inv_container.qstar_high = "ERROR"
@@ -489,5 +489,5 @@
                 self._manager.plot_theory(name="High-Q extrapolation")
                 msg = "Error occurred computing high-Q "
-                msg += "invariant: %s" % sys.exc_value
+                msg += "invariant: %s" % exc
                 wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                       type="stop"))
@@ -496,6 +496,6 @@
             try:
                 self._manager.plot_theory(name="High-Q extrapolation")
-            except:
-                logger.error(sys.exc_value)
+            except Exception as exc:
+                logger.error(exc)
 
     def get_qstar(self, inv):
@@ -625,6 +625,6 @@
             background = self.get_background()
             scale = self.get_scale()
-        except:
-            msg = "Invariant Error: %s" % (sys.exc_value)
+        except Exception as exc:
+            msg = "Invariant Error: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg, type="stop"))
             return
@@ -641,6 +641,6 @@
             inv, npts_low = self.set_extrapolation_low(inv=inv, low_q=low_q)
             inv, npts_high = self.set_extrapolation_high(inv=inv, high_q=high_q)
-        except:
-            msg = "Error occurred computing invariant: %s" % sys.exc_value
+        except Exception as exc:
+            msg = "Error occurred computing invariant: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                   info="warning", type="stop"))
@@ -652,6 +652,6 @@
         try:
             self.get_qstar(inv=inv)
-        except:
-            msg = "Error occurred computing invariant: %s" % sys.exc_value
+        except Exception as exc:
+            msg = "Error occurred computing invariant: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                   info="warning",
@@ -674,7 +674,6 @@
             porod_const = self.get_porod_const()
             contrast = self.get_contrast()
-        except:
-            msg = r_msg + "Error occurred computing invariant: %s" % \
-                                                            sys.exc_value
+        except Exception as exc:
+            msg = r_msg + "Error occurred computing invariant: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                   info="error",
@@ -685,6 +684,6 @@
                             extrapolation=extrapolation)
             #compute surface and set value to txtcrtl
-        except:
-            msg = "Error occurred computing invariant: %s" % sys.exc_value
+        except Exception as exc:
+            msg = "Error occurred computing invariant: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                   info="warning",
@@ -695,6 +694,6 @@
                              extrapolation=extrapolation)
 
-        except:
-            msg = "Error occurred computing invariant: %s" % sys.exc_value
+        except Exception as exc:
+            msg = "Error occurred computing invariant: %s" % exc
             wx.PostEvent(self.parent, StatusEvent(status=msg,
                                                   info="warning",
@@ -845,11 +844,13 @@
             if attr.__class__.__name__ == "StaticText":
                 return
-            if value in ["True", "False", True, False]:
-                value = bool(value)
+            if value in ["True", True]:
+                value = 1
+            elif value in ["False", False]:
+                value = 0
             else:
                 value = str(value)
             attr.SetValue(value)
-        except:
-            logger.error("Invariant state: %s", sys.exc_value)
+        except Exception as exc:
+            logger.error("Invariant state: %s", exc)
 
     def get_bookmark_by_num(self, num=None):
@@ -867,7 +868,7 @@
         try:
             _, _, current_state, comp_state = self.state.bookmark_list[int(num)]
-        except:
-            logger.error(sys.exc_value)
-            raise ValueError, "No such bookmark exists"
+        except Exception as exc:
+            logger.error(exc)
+            raise ValueError("No such bookmark exists")
 
         # set the parameters
@@ -962,6 +963,6 @@
             self.state.state_list[str(self.state.state_num)] = \
                     self.state.clone_state()
-        except:
-            logger.error(sys.exc_value)
+        except Exception as exc:
+            logger.error(exc)
 
         self._set_undo_flag(True)
@@ -1006,6 +1007,6 @@
             try:
                 del self.state.state_list[str(i)]
-            except:
-                logger.error(sys.exc_value)
+            except Exception as exc:
+                logger.error(exc)
         # Enable the undo button if it was not
         self._set_undo_flag(True)
@@ -1071,6 +1072,6 @@
             try:
                 del self.state.state_list[str(i)]
-            except:
-                logger.error(sys.exc_value)
+            except Exception as exc:
+                logger.error(exc)
 
         # try to add new state of the text changes in the state_list
@@ -1086,6 +1087,6 @@
             self.state.state_num = self.state.saved_state['state_num']
             self.state.state_list[str(self.state.state_num)] = self.state.clone_state()
-        except:
-            logger.error(sys.exc_value)
+        except Exception as exc:
+            logger.error(exc)
 
         self._set_undo_flag(True)
@@ -1108,6 +1109,6 @@
             self.state.saved_state[name] = str(value)
             self.state.state_list[str(self.state.state_num)] = self.state.clone_state()
-        except:
-            logger.error(sys.exc_value)
+        except Exception as exc:
+            logger.error(exc)
 
     def _get_input_list(self):
@@ -1118,6 +1119,6 @@
         compute_num = self.state.saved_state['compute_num']
         # find values and put into the input list
-        for key1, value1 in self.state.state_list[str(compute_num)].iteritems():
-            for key, _ in self.state.input_list.iteritems():
+        for key1, value1 in self.state.state_list[str(compute_num)].items():
+            for key, _ in self.state.input_list.items():
                 if key == key1:
                     self.state.input_list[key] = value1
